namespace mylib{
	using System.Drawing;
	using System;
	using mylib;
	
	public class CastleFlag: MCharacter{

		public CastleFlag(StageManager E,double xx,double yy,int code,int option)
			:base(E,xx,yy,code,option){
		}


		protected override void init(double xx,double yy,int option){
			mind=Mind.Other;

			charBodyWidth  = 32;
			charBodyHeight = 48;
			charSpriteWidth  = 32;
			charSpriteHeight = 48;
			z=Zindex.StageZ-1;
			yMove=-6;

			imgWalk=getImageID(EnemyParameter.CastleFlag_imgWalk);
			Face=imgWalk;

			Set(x,y,false,null);
			MoveTo(x,y);
		}
	//----------------------
		public void Set(double xx,double yy,bool v,ObjGroup group){
			x=xx;
			y=yy;
			SetSize();
			MoveTo(x,y);
			Face=imgWalk;
			Visible=v;
			if(group!=null)GroupEntry(group);
		}
		public void Reset(){
			Visible=false;
		}

	//----------------------
		public override bool Action(){
			innerTimer++;
			return true;
		}
	//----------------------
		public override bool OnCollision(MCharacter obj){
			return false;
		}
	//----------------------
		public override int Kill(){return 1;}
		public override int Kill(KillMode Kmode){return 1;}



	}


}