namespace mylib{

	using System;	
	
	public class Chubo :MCharacter{
		
		public Chubo(StageManager s,double xx,double yy,int code,int option)
			:base(s,xx,yy,code,option)
		{
			basicInit();

			hasGroupCollision=true;


			imgWalk  = getImageID(EnemyParameter.Chubo_imgWalk);
			imgDie   = getImageID(EnemyParameter.Chubo_imgDie);

			Face=imgWalk;
			init(xx,yy,option);
		}
		
		
		protected new virtual void init(double xx,double yy,int option){
			peta=true;


		}
//----------------------
		public override bool Action(){
		 if(alive<0)return false;
		  if(manager.CheckScreen(this) < 0){
			if(screenDrop){Kill(KillMode.Drop);return false;}
			else
			return false;
		  }
		 innerTimer++;
//		  if(hasGroupCollision)myGroup.GroupCollision(this);
//		  if(alive<0)return false;

		  if(basicMove()<0)return false;
		  
		  Face=imgWalk;



			 if(dropKillCheck()){Kill(KillMode.Drop);return false;}
		 return true;
		}


//----------------------
		public override bool OnCollision(MCharacter obj){
		 if(alive<0)return false;
	//	 if(obj.alive<0)return false;
		 if(manager.CheckScreen(this) < 0)return false;
		  switch(obj.Mind){
		   case mylib.Mind.Enemy:
		    if(!hasGroupCollision || !obj.HasGroupCollision)break;
			 if(x >= obj.X)
				xMove= Math.Abs(xMove);
			 else
				xMove=-Math.Abs(xMove);

		   break;
		   case mylib.Mind.Fire:
			if(registFire > 0)break;
			obj.GetScore(score);
			Kill(KillMode.Fire);
		   break;
		   case mylib.Mind.Upper:
			if(registUpper > 1)break;
			if(registUpper > 0){
				yMove=-yBounce;
				break;
			}
			 obj.GetScore(score);
			 Kill(KillMode.Upper);
		   break;
		   case mylib.Mind.Kick:
			if(registKick>0)break;
			obj.GetScore(score);
			obj.GetKickBonus();
			Kill(KillMode.Kick);
		   break;
		   case mylib.Mind.Player:
			if(obj.Star){
				obj.GetStarBonus();
				obj.GetScore(score);
				Kill(KillMode.Star);
			}else{
			 bool h = stepCollision(obj); // ݂


			 if(h && registPress <= 0){
			    if(registPress < 0){
				Kill(KillMode.Press);
				obj.StepEnemy(this);
				obj.GetScore(score);
			    }
			 }else
			 {
				obj.Damage(this);
			 }
			}
		   break;
		  }
		 return true;
		}



//----------------------
		public override int Kill(){return Kill(KillMode.Other);}
//		public override int Kill(KillMode k){return Kill((int)k);}
		public override int Kill(KillMode Kmode){
		 if(alive<0)return -1;
		  switch(Kmode){
			case KillMode.Drop:
			break;
			case KillMode.Star: goto case KillMode.Kick;
			case KillMode.Upper:goto case KillMode.Kick;
			case KillMode.Fire: goto case KillMode.Kick;
			case KillMode.Kick:
			 peta=false;
			 MCharacter dd=manager.CreateEffect(CharCode.DyingEffect,x,y,0);
			 dd.SetMaster(this);
			break;
			case KillMode.Press:
			 (manager.CreateEffect(CharCode.DyingEffect,x,y,0)).SetMaster(this);
			break;
		  }

		  return base.Kill(Kmode);
		}
		

		protected virtual bool dropKillCheck(){
		 if(!screenDrop)return false;
		if((x > manager.ScrollXmax+manager.VirtualWidth - charBodyWidth) ||
		  (x < manager.ScrollXmin) ||
		  ((y > manager.ScrollYmax+manager.VirtualHeight) && yDropKill)
		  )return true;
		  return false;
		}












		protected virtual void basicInit(){
			alive=1;
			charBodyWidth    = 24;
			charBodyHeight   = 24;
			charSpriteWidth  = 32;
			charSpriteHeight = 32;

			registFire  = -1; //
			registUpper = -1; //
			registKick  = -1; //
			registPress = -1; //

			mind = mylib.Mind.Enemy;



			xMove=-2;
			z=Zindex.EnemyZ;
			xSpeedMax=6;
			xSpeedMin=.9;
			xAccel =3;
			
			yMove=0;
			yAccel=3;
			ySpeedMax=15;
			yJump    =0;
			yBounce=35.5;
			
			checkStage= true;  // wĩIuWFNgƂ̔邩ǂ
			checkFloor= false; // ̒[Ń^[邩
			checkWall = true;  // ǂ𖳎邩
			hasGroupCollision=true; // mŏՓ˔肷邩
			screenDrop=false; // ʊOɏo_ŎSƂ
			yDropKill=true; //_ŎSƂ邩

			oldX=x;
			oldY=y;
			SetSize();
		}
		
		
	}



}