namespace mylib{
	using System.Drawing;
	using System;
	using mylib;
	
	class FireBubble: Chubo{
		private int jumpRate;
		private int animateCounter;
		private double topY;
		private double bottomY;

		public FireBubble(StageManager E,double xx,double yy,int code,int option)
			:base(E,xx,yy,code,option){
		}


		protected override void init(double xx,double yy,int option){

			xMove=0;
			yMove=0;
			yJump  = EnemyParameter.FireBubble_yJump;
			yAccel = EnemyParameter.FireBubble_yAccel;

			score = 800;

			jumpRate = EnemyParameter.FireBubble_jumpRate;
			animateCounter=-manager.M(jumpRate);
			
			imgWalk  = getImageID(EnemyParameter.FireBubble_imgWalk);
			imgDie   = getImageID(EnemyParameter.FireBubble_imgDie);
			Face=imgWalk;
			
			registFire  = 2; //
			registUpper = 2; //
			registKick  = 2; //
			registPress = 2; //
			hasGroupCollision = false;

			
			charBodyWidth    = 24;
			charBodyHeight   = 24;
			charSpriteWidth  = 32;
			charSpriteHeight = 32;
			verticalAlign=Valign.Middle;

			x=Math.Floor(xx/manager.BlockWidth ) * manager.BlockWidth+(manager.BlockWidth-charBodyWidth)/2;
			y=Math.Floor(yy/manager.BlockHeight) * manager.BlockHeight;
			topY=y+2;
			y+=manager.BlockHeight * 2;
			bottomY=y;
			Z=Zindex.StageZ-1;

			double ya=yAccel,yj=-yJump,ytmp=0;
			for(int i=0;i<100;i++){yj+=ya;ytmp+=yj;if(yj>=0)break;}

			y=y-ytmp;
			bottomY=y;


			SetSize();
			
		}






//----------------------
		public override bool Action(){
		  if(alive<0)return false;
		  if(manager.CheckScreen(x,topY,charSpriteWidth,bottomY)< 0)return false;
		 innerTimer++;

		  yMove+=yAccel;
		  if(y > bottomY){
			y=bottomY;
			yMove=0;
			animateCounter=-jumpRate;
			Visible=false;
		  }else
		  if(y == bottomY){
			if(animateCounter>=0){
			 yMove=-yJump;
			 Visible=true;
			}else{
			 yMove=0;
			}
		  }

		    VFace = ( yMove < 0 ) ? 1 : -1;

		  y+=yMove;
		  animateCounter++;
		 return true;

		}

//----------------------
		public override bool OnCollision(MCharacter obj){// sg
		 if(alive<0)return false;
		 if(obj.Alive<0)return false;
		 if(manager.CheckScreen(this) < 0)return false;
		  if(yMove==0)return false; // x~͔𖳎
		  switch(obj.Mind){
			case mylib.Mind.Player:
				obj.Damage(this);
			break;
			default:
			break;
		  }
		 return true;
		}



	}
}