namespace mylib
{
	public class GamePad{
	  private int x=0;
	  private int y=0;
	  private int[] buttons= new int[4];
	  
	  public int X{
		set{
			x=value;
		}
		get{
			return x;
		}
	  }

	  public int Y{
		set{
			y=value;
		}
		get{
			return y;
		}
	  }

	  public int ButtonA{
		set{
			buttons[0]=value;
		}
		get{
			return buttons[0];
		}
	  }


	  public int ButtonB{
		set{
			buttons[1]=value;
		}
		get{
			return buttons[1];
		}
	  }


	  public int ButtonC{
		set{
			buttons[2]=value;
		}
		get{
			return buttons[2];
		}
	  }


	  public int ButtonD{
		set{
			buttons[3]=value;
		}
		get{
			return buttons[3];
		}
	  }


	  
	  public int GetPadStatus(){
		return	(         x +2 ) * 100000 +
			(         y +2 ) *  10000 +
			(buttons[0] +2 ) *   1000 +
			(buttons[1] +2 ) *    100 +
			(buttons[2] +2 ) *     10 +
			(buttons[3] +2 ) *      1
			;
	  }
	  public int SetPadStatus(int st){
		x         =st/100000%10;
		y         =st/10000%10;
		buttons[0]=st/1000%10;
		buttons[1]=st/100%10;
		buttons[2]=st/10%10;
		buttons[3]=st/1%10;
		return st;
	  }
	  public void Reset(){
		x         =0;
		y         =0;
		buttons[0]=0;
		buttons[1]=0;
		buttons[2]=0;
		buttons[3]=0;
	  }
	/*
	  public boolean A(){
		return (buttons[0]!=0);
	  }
	  public boolean B(){
		return (buttons[1]!=0);
	  }
	*/
	} //
}