namespace mylib{
	using System.Drawing;
	using System;
	using mylib;
	
	class HammerBaki: Chubo{
		private int hammerRate;
		private int hammerRate2;
		private int hammerCounter;
		private int jumpRate;
		private int jumpCounter;
		private int ignoreFloor;
		private int ignoreFloorRate=18;

		public HammerBaki(StageManager E,double xx,double yy,int code,int option)
			:base(E,xx,yy,code,option){
		}


		protected override void init(double xx,double yy,int option){
			score      = 2000;

			registFire  = -1; //
			registUpper = -1; //
			registKick  = -1; //
			registPress = -1; //
			hasGroupCollision=false;
			
			charBodyWidth =24;
			charBodyHeight=48;
			charSpriteWidth =32;
			charSpriteHeight=60;

			imgWalk = getImageID(EnemyParameter.HammerBaki_imgWalk);
			imgDie  = getImageID(EnemyParameter.HammerBaki_imgDie);
			Face=imgWalk;

			jumpRate  = EnemyParameter.HammerBaki_jumpRate;
			hammerRate = EnemyParameter.HammerBaki_hammerRate;
			hammerRate2= EnemyParameter.HammerBaki_hammerRate2;
			xMove     = EnemyParameter.HammerBaki_xMove;
			xAccel    = EnemyParameter.HammerBaki_xAccel;
			yAccel    = EnemyParameter.HammerBaki_yAccel;
			yJump     = EnemyParameter.HammerBaki_yJump;
			ySpeedMax=EnemyParameter.HammerBaki_ySpeedMax;

			hammerCounter = manager.M(hammerRate);
			jumpCounter   = manager.M(jumpRate);

			SetSize();
		
		}





//----------------------
		public override bool Action(){
		  if(alive<0)return false;
		  if(manager.CheckScreen(this)< 0)return false;
		 innerTimer++;
		   if(manager.M(15)==1)xMove*=-1;

		   yMove+=yAccel;

		   double ctX      = x + charBodyWidth / 2;
		   double flPoint  = y + charBodyHeight     + yMove;
		   double flPoint2 = flPoint + manager.BlockHeight;
		   int fl1=manager.CheckFloorBlock(manager.GetXYPointObject(ctX,flPoint ));
		   int fl2=manager.CheckFloorBlock(manager.GetXYPointObject(ctX,flPoint2 ));
		  if(yMove>0){
		    if(  (fl1 > 0)){
			if(
			   (fl2 > 0) ||
			   (flPoint2 > manager.ScrollYmax + manager.VirtualHeight) ||
			   (ignoreFloor <= 0 )||
			   (false)
			){
			 yMove=0;
			 y=Math.Floor(flPoint/manager.BlockHeight)*manager.BlockHeight-charBodyHeight;
			}
		   }
		  }
		  if( yMove < 10 ){
			double blPoint  = y + charBodyHeight *.5;
			int bl1=manager.CheckFloorBlock(manager.GetXYPointObject(ctX,blPoint));
		    if( (bl1 > 0) ){
			yMove=0;
			y=Math.Floor(blPoint/manager.BlockHeight)*manager.BlockHeight-charBodyHeight;
		    }
		  }

		   if(yMove==0 && jumpCounter < 0){
			yMove=-yJump;
			jumpCounter=manager.M(jumpRate)+30;
			ignoreFloor=manager.M(ignoreFloorRate);
		   }

		  Player PL=manager.GetPlayerObject(0);
		  hFace=(PL.X > x ) ? 1 : -1 ;

		  if(innerTimer > EnemyParameter.HammerBaki_dashStart){
			xMove=hFace*6;
		  }

		   x+=xMove;//+hFace;
		   y+=yMove;

			if(hammerCounter < 0){
				if(hammerCounter >-hammerRate2*6-10){
					if(hammerCounter% hammerRate2==0)
					 manager.CreateEnemy(CharCode.Hammer,x,y,hFace).SetMaster(this);
	//				 manager.CreateMessage("Kb" + hammerRate,x,y);
				}else{
					  hammerCounter=hammerRate+manager.M(30);//manager.M(hammerRate)+30;
				}
			}


		  jumpCounter--;
		  hammerCounter--;
		  ignoreFloor--;

		 if(dropKillCheck()){Kill(KillMode.Drop);return false;}
		 return true;
		}







	}
}