namespace mylib{
	using System.Drawing;
	using System;
	using mylib;
	
	class Item: MCharacter{
		private int cCounter=12;
		private int mode=0;

		public Item(StageManager E,double xx,double yy,int code,int option)
			:base(E,xx,yy,code,option){
		}


		protected override void init(double xx,double yy,int option){
			score=1000;
			x=Math.Floor(xx / manager.BlockWidth ) * manager.BlockWidth;
			y=Math.Floor(yy / manager.BlockHeight) * manager.BlockHeight;
				charBodyWidth  = 24;
				charBodyHeight = 24;
				charSpriteWidth  = 32;
				charSpriteHeight = 32;
			z=Zindex.StageZ-1;
			xMove=5;
			xSpeedMax=6;
			xAccel =3;
			
			yMove=0;
			yAccel=3;
			ySpeedMax=12;
			yJump    =0;
			
			checkStage= true;
			checkFloor= false;
			checkWall = true;

			mode=charCode;
			
			string im="";

			switch(charCode){
				case mylib.CharCode.Kinoko:
					im=EnemyParameter.Kinoko_imgWalk;
				break;
				case mylib.CharCode.Flower:
					im=EnemyParameter.Flower_imgWalk;
					xAccel=0;
					xMove=0;
				break;
				case mylib.CharCode.Star:
					im=EnemyParameter.Star_imgWalk;
					yJump=20.5;
					xAccel =3;
				break;
				case mylib.CharCode.Tsuta:
					charBodyWidth  = 32;
					charBodyHeight = 20;
					charSpriteWidth  = 32;
					charSpriteHeight = 32;
					xMove=0;
					yMove=-6;
					yAccel=0;
					im=EnemyParameter.Tsuta_imgWalk;
				break;
				case mylib.CharCode.Iget:
					im=EnemyParameter.Iget_imgWalk;
				break;
				case mylib.CharCode.Poison:
					im=EnemyParameter.Poison_imgWalk;
				break;
			}
		

			imgWalk=getImageID(im);
			imgDie=imgWalk;
			Face=imgWalk;

			
			x+=cSprX;
		}

	//----------------------
		public override bool Action(){
		  innerTimer++;
		 if(charCode!=mylib.CharCode.Tsuta){
		  if(alive<0)return false;
		  if(manager.CheckScreen(this) < 0){Kill();return false;}
		 }

		  if(cCounter-->0){
			oldY=y;
			y-=2;
		  }else{
		   basicMove();
		   if(charCode==CharCode.Tsuta){
			  if(y<=0){
				MCharacter mm=manager.CreateObject(CharCode.TsutaUp,x,y,0);
				Kill(KillMode.Drop);
				return false;
			  }
			int bp=manager.CheckWallBlock(
				manager.GetXYPointObject(x+charBodyWidth/2,y+charBodyHeight/2));

	//		 manager.DBGn("y="+y+" bp="+bp);
			switch(bp){
			 case -2: break;
			 case -3: break;

			 case  0:goto case -1; 
			 case -1:
				manager.SetXYPointObject(x+charBodyWidth/2,y+charBodyHeight/2,Blocks.Tsuta);
			 break;
			 default:
	//			kill(KillMode.Drop);
			 return false;
			}

		   }else{
			Z=Zindex.ItemZ;
			//myGroup.groupCollision(this);

		    if(charCode==mylib.CharCode.Flower){
			MCharacter p=manager.GetPlayerObject(0);
			if(x<p.X)HFace= 1;
			else	 HFace=-1;
		    }
		   }
		 } // end if

		 return true;
		}
	//----------------------
		public override bool OnCollision(MCharacter obj){
		  if(cCounter>0)return false;
		 if(alive<0)return false;
		 if(charCode==mylib.CharCode.Tsuta)return false;
		 switch(obj.Mind){

			case Mind.Upper:
			 if(obj.X+obj.Width/2 > x+charBodyWidth/2)xMove=-xAccel;
			 else xMove=xAccel;
			 yMove = -yBounce;
			break;

			case Mind.Player:
//			 manager.DBGn("Player!!");
			 ((Player)obj).GetItem(charCode);
			 if(mode==mylib.CharCode.Iget)manager.CreateMessage("+1GET+",x,y);
			 Kill();
			break;
		 }
		 return true;
		}



	}


}