namespace mylib{
	using System.Drawing;
	using System;
	using mylib;
	
	class Pata: Chubo{
//		private int kameType=CharCode.Pata;
		public Pata(StageManager E,double xx,double yy,int code,int option)
			:base(E,xx,yy,code,option){
		}


		protected override void init(double xx,double yy,int option){
		
		 
			 score=400;

			charSpriteHeight=38;

			string iWalk,iDie;
			switch(charCode){
				default: goto case mylib.CharCode.Pata;
				case mylib.CharCode.Pata:
				 xMove=-3;
				 yMove=.1;
				 registPress=0;
				 yJump=12.1;
				 yAccel=1;
				 iWalk  = EnemyParameter.PataGR_imgWalk;
				 iDie   = EnemyParameter.PataGR_imgDie;
				break;
				case mylib.CharCode.PataV:
				 xMove=0;
				 yMove=3.6;
				 xAccel=0;
				 yAccel=.2;
				 ySpeedMax=7.2;
				 registPress=0;
				 yDropKill  = false;
				 checkWall  = false;
				 checkFloor = false;
				 checkStage = false;
				 hasGroupCollision=false;
				 iWalk  = EnemyParameter.PataRD_imgWalk;
				 iDie   = EnemyParameter.PataRD_imgDie;
				break;
				case mylib.CharCode.PataH:
				 xMove=-3.6;
				 yMove=0;
				 xAccel=-.2;
				 yAccel=0;
				 xSpeedMax=7.2;
				 registPress=0;
				 checkWall  = false;
				 checkFloor = false;
				 checkStage = false;
				   iWalk  = EnemyParameter.PataRD_imgWalk;
				   iDie   = EnemyParameter.PataRD_imgDie;
				break;
			}
			imgWalk  = getImageID(iWalk);
			imgDie   = getImageID(iDie);

//			kameType = option;
			
			

			Face=imgWalk;
			SetSize();


		}

	//----------------------
		public override bool Action(){
		  if(alive<0)return false;
		  if(manager.CheckScreen(this)< 0)return false;
		 innerTimer++;
//		  if(hasGroupCollision)myGroup.groupCollision(this);
//		  if(alive<0)return false;

		  basicMove();

			Player p=manager.GetPlayerObject(0);

		  switch(charCode){
			case mylib.CharCode.Pata:
			break;
			case mylib.CharCode.PataV:
			 hFace=(x > p.X) ? -1 : 1;
			  if(Math.Abs(yMove)>=ySpeedMax)yAccel*=-1;
			 break;
			case mylib.CharCode.PataH:
			 xMove+=xAccel;
			  if(Math.Abs(xMove)>=xSpeedMax)xAccel*=-1;
			break;
		  } //



		 if(dropKillCheck()){Kill(KillMode.Drop);return false;}
		 return true;
		} //


	//----------------------
		public override bool OnCollision(MCharacter obj){
		 if(alive<0)return false;
		 if(obj.Alive<0)return false;
		 if(manager.CheckScreen(this) < 0)return false;

		  MCharacter m;

		  switch(obj.Mind){
		   case mylib.Mind.Upper:
			 obj.GetScore(score);
			if(charCode==mylib.CharCode.Pata || charCode==mylib.CharCode.PataV){
				int cc=(charCode==mylib.CharCode.Pata) ? 
						mylib.CharCode.KameGR : mylib.CharCode.KameRD;
				m = manager.CreateEnemy(cc,x,y-3,0);
			}else
			{
				m = manager.CreateEnemy(CharCode.KameRD,x,y-3,0);
			}
			Visible=false;
			((Kame)m).ConvertKame(this,1);
			 if(m!=null){
				if(obj.X+obj.Width/2 > x+charBodyWidth/2)m.XMove=3;
				else m.XMove=-3;
			 }
			Kill(KillMode.Upper);
		   return false;

		   case mylib.Mind.Player:
			if(((Player)obj).Star == true){
				obj.GetStarBonus();
				obj.GetScore(score);
				Kill(KillMode.Star);
			}else{


			 bool h = stepCollision(obj);


			 if(h){
				Visible=false;
				switch(charCode){
					default:goto case mylib.CharCode.Pata;
					case mylib.CharCode.Pata:
					 obj.StepEnemy(this);
					 obj.GetScore(score);
					 m = manager.CreateEnemy(CharCode.KameGR,x,y+3,0);

					 Kill(KillMode.Press);
					break;

					case mylib.CharCode.PataV:
					case mylib.CharCode.PataH:
					 obj.StepEnemy(this);
					 obj.GetScore(score);
					 m = manager.CreateEnemy(CharCode.KameRD,x,y+3,0);

					 Kill(KillMode.Press);
					break;
				}
				((Kame)m).ConvertKame(this,0);
				return false;
			 }else
			 {
				obj.Damage(this);
			 }
			}
		   break;
		   default:
		    return base.OnCollision(obj);
		  }
		 return true;
		}

		public override int Kill(){return Kill(KillMode.Other);}
		public override int Kill(KillMode kmode){
			if(kmode== KillMode.Upper || kmode== KillMode.Press){
				//manager.DBGn("KAME->");
				return base.Kill(KillMode.Drop);
			}
			return base.Kill(kmode);
		}
		

		protected override bool stepCollision(MCharacter m){
		 if((m.YMove>5) && (yMove<10))return true; // ђʂă_[WɂȂĂ܂΍
		 return base.stepCollision(m);
		}




















	}
}