namespace mylib{
	using System.Drawing;
	using System;
	using mylib;
	
	class Toge: Chubo{
		private bool tamagoFlag=false;

		public Toge(StageManager E,double xx,double yy,int code,int option)
			:base(E,xx,yy,code,option){
		}


		protected override void init(double xx,double yy,int option){
			imgWalk  = getImageID(EnemyParameter.Toge_imgWalk);
			imgDie   = getImageID(EnemyParameter.Toge_imgDie);

			Face=imgWalk;

			registUpper=1;
			registPress=1;
			yBounce=25.1;
			charSpriteHeight=38;

			if(option < 0){ // 珢҂ꂽꍇ
			  Player p=manager.GetPlayerObject(0);
			  if(p.X>x){
				HFace = 1;
				xMove = Math.Abs(xMove);
			  }
			  inc();
			  tamagoFlag=true;
			}
			
			SetSize();
		}



		private void inc(){
			EnemyParameter.LiveCannonCnt++;
//			manager.DBG("cannonCNT +"+EnemyParameter.LiveCannonCnt);
		}
		private void dec(){
			if(EnemyParameter.LiveCannonCnt>0)
				EnemyParameter.LiveCannonCnt--;
//			manager.DBG("cannonCNT -"+EnemyParameter.LiveCannonCnt);
		}



//----------------------
		public override bool Action(){
		 if(alive<0)return false;
		  if(manager.CheckScreen(this) < 0){
			if(tamagoFlag){Kill(KillMode.Drop);return false;}
			else
			return false;
		  }
		  innerTimer++;
		  basicMove();

//		  if(hasGroupCollision)myGroup.groupCollision(this);
//		  if(alive<0)return false;

		  if(dropKillCheck()){Kill(KillMode.Drop);return false;}
		 return true;
		}



		public override int Kill(){return Kill(KillMode.Other);}
		public override int Kill(KillMode kmode){
		 if(alive<0)return -1;
		 if(tamagoFlag)dec();
		  return base.Kill(kmode);
		}






	}
}