namespace mylib{
	using System;
	using mylib;

	class WarpHall:MCharacter{
		private static int warpIDcnt=0;
		private int warpID;
		 public int WarpID{
			get{return warpID;}
		 }
		
		private int mode=CharCode.DokanDown;

		public WarpHall(StageManager E,double xx,double yy,int code,int option)
			:base(E,xx,yy,code,option){
		}


		protected override void init(double xx,double yy,int option){
			x=Math.Floor(xx / manager.BlockWidth  ) * manager.BlockWidth;
			y=Math.Floor(yy / manager.BlockHeight ) * manager.BlockHeight;
				charBodyWidth  = 16;	//蔻TCY
				charBodyHeight = 16;
				charSpriteWidth  = 16; //OtBbÑTCY
				charSpriteHeight = 16;

			mode=charCode;
			switch(mode){
				case CharCode.DokanUp:
					hFace= 0;
					vFace=-1;
					x+=manager.BlockWidth  - charBodyWidth  / 2;
					y-=charBodyHeight /2;
				break;
				case CharCode.TsutaUp:
					hFace= 0;
					vFace=-1;
					x+=charBodyWidth  / 2;
					//y-=charBodyHeight /2;
					//charBodyWidth+=charBodyWidth/2;
					if(y<0)y=0;
				break;
				case CharCode.DokanDown:
					hFace= 0;
					vFace= 1;
					x+=manager.BlockWidth  - charBodyWidth  / 2;
					y+=manager.BlockHeight - charBodyHeight *.2;
				break;
				case CharCode.DokanLeft:
					vFace= 0;
					hFace=-1;
					x-=charBodyWidth /2;
					y+=manager.BlockHeight - charBodyHeight- 6+2;
				break;
				case CharCode.DokanRight:
					vFace= 0;
					hFace= 1;
					x+=manager.BlockWidth  - charBodyWidth /2 -2;
					y+=manager.BlockHeight - charBodyHeight-6;
				break;
			}
			
			MoveTo(x,y);
			warpID=warpIDcnt++;
			//ENV.DBGn("warpID="+warpID+" =" +ENV.GS.warpSrc[warpID]);
			Visible=false;
#if mytest
	Visible=true;
	Z=200;
#endif
			sprite.BitmapID=0;
			SetSize();

		}







	//----------------------
		public static void Reset(){
			warpIDcnt=0;
		}
	//----------------------
		public override bool Action(){
			innerTimer++;
			return true;
		}
	//----------------------
		public override bool OnCollision(MCharacter m){
		   if(m.Mind==mylib.Mind.Player){
			Player p=(Player)m;
			if( p.GamePad.X * hFace > 0 || p.GamePad.Y * vFace > 0){
				if(vFace==0){
					p.Y=y+charBodyHeight-p.Height;
					p.YMove=-0.01;
				}else
				if(hFace==0){
				  p.XMove=0;
				  if(p.X>x)p.X=x;
				  else
				  if(p.X+p.Width<x+charBodyWidth){
					p.X=x+charBodyWidth-p.Width;
				  }
				}
				p.DokanWarp(mode,warpID);
				Kill();
			}
		   }
			return false;
		}





 	}
}