namespace mylib{
	using System.Drawing;
	using System;
	using mylib;
	
	public class BounceBlock: EffectObject{
		public int replaceItem=-1;
		private double firstY=0;
		public int maxcnt=30;

		public BounceBlock(StageManager E,double xx,double yy,int code,int option)
			:base(E,xx,yy,code,option){
//			init(xx,yy,option);
		}


		protected override void init(double xx,double yy,int option){
			x=Math.Floor(xx / manager.BlockWidth ) * manager.BlockWidth;
			y=Math.Floor(yy / manager.BlockHeight) * manager.BlockHeight;
			firstY=y;
//			z=Zindex.EffectZ120;
			xMove=0;
			yMove=-8;
			xAccel=0;
			yAccel=2;
			charBodyWidth  = 24;
			charBodyHeight = 32;
			charSpriteWidth  = (int)Math.Round(manager.BlockWidth);
			charSpriteHeight = (int)Math.Round(manager.BlockHeight);

			Visible=true;
			string ss=manager.GetBlockImageName(option);
			sprite.BitmapImageName=ss;
			//if(im!=null)sprite.Face=im;
			
			
			mind=Mind.Upper;

			SetSize();
			 x+=cSprX;
			MoveTo(x,y,z);
		}

	//----------------------
		public override bool Action(){
		if(replaceItem>=0){
			manager.SetXYPointObject(x,firstY,replaceItem,0);
			replaceItem=-1;
		}
		if(yMove<0){
		 manager.Enemies.GroupCollision(this);
		 manager.Others.GroupCollision(this);
		}

		if(y>=firstY && yMove>0)Kill(0);
		return base.Action();
		}
	//----------------------
		public override bool OnCollision(MCharacter obj){
			return true;
		}
	//----------------------
		public override int Kill(KillMode kmode){
			return base.Kill(KillMode.Other);
		}



	}


}