namespace mylib{
	using System.Drawing;
	using System;
	using mylib;
	
	public class BrokenBlock: EffectObject{
//		private int replaceItem=-1;
		private double firstY=0;
		private Sprite[] blk=new Sprite[4];
		
		private double[] xb = new double[4];
		private double[] yb = new double[4];
		private double[] xm = new double[4];
		private double[] ym = new double[4];
		private double[] xa = new double[4];
		private double[] ya = new double[4];
		public BrokenBlock(StageManager E,double xx,double yy,int code,int option)
			:base(E,xx,yy,code,option){
		}


		protected override void init(double xx,double yy,int option){
			actionCnt=80;

			x=Math.Floor(xx / manager.BlockWidth ) * manager.BlockWidth;
			y=Math.Floor(yy / manager.BlockHeight) * manager.BlockHeight;
			 firstY=y;
			Z=Zindex.EffectZ;
			charSpriteWidth  = (int)Math.Ceiling(manager.BlockWidth/2);
			charSpriteHeight = (int)Math.Ceiling(manager.BlockHeight/2);
			charBodyWidth  = charSpriteWidth;
			charBodyHeight = charSpriteHeight;
		
			xb[0]= x;
			yb[0]= y;
			xm[0]=-3;
			ym[0]=-22.1;
			xa[0]=-.4;
			ya[0]= 3;

			xb[1]= x+charSpriteWidth;
			yb[1]= y;
			xm[1]= 4;
			ym[1]=-22.1;
			xa[1]= .4;
			ya[1]= 3;

			xb[2]= x;
			yb[2]= y+charSpriteHeight;
			xm[2]= -6;
			ym[2]=-18.1;
			xa[2]=-.4;
			ya[2]= 3;

			xb[3]= x+charSpriteWidth;
			yb[3]= y+charSpriteHeight;
			xm[3]= 6;
			ym[3]=-18.1;
			xa[3]= .4;
			ya[3]= 3;


//			Image im=manager.GameStage.GetBlockImage(option);
			 for(int i=0;i<4;i++){
				blk[i]=new Sprite(xb[i],yb[i],z);
				//blk[i].setBitmap(im);
				blk[i].BitmapImageName=manager.GetBlockImageName(option);
				blk[i].MoveTo(xb[i],yb[i]);
				blk[i].SetSize(charSpriteWidth,charSpriteHeight);
				blk[i].Visible=true;
			 }
			mind=mylib.Mind.Other;
		}

	//----------------------
		public override bool Action(){
		 innerTimer++;
		 for(int i=0;i<4;i++){
			xm[i]+=xa[i];
			ym[i]+=ya[i];
			xb[i]+=xm[i];
			yb[i]+=ym[i];
			blk[i].MoveTo(xb[i],yb[i]);
		 }
		  if(innerTimer>actionCnt)Kill(KillMode.Other);
		  return true;
		}
	//----------------------
		public override int Kill(KillMode kmode){
			if(alive<0)return -1;
			 for(int i=0;i<4;i++){
				if(blk[i]!=null)blk[i].Kill();
				blk[i]=null;
			 }
			return base.Kill(KillMode.Other);
		}


		public override bool DrawEntry(){
			 for(int i=0;i<4;i++){
				if(blk[i]!=null)blk[i].DrawEntry();
			 }
			return true;
		}


	}


}