namespace mylib{
	using System.Drawing;
	using System;
	using mylib;
	
	class Cannon: Chubo{
		private int attackRate;
		private int attackCounter;

		public Cannon(StageManager E,double xx,double yy,int code,int option)
			:base(E,xx,yy,code,option){
		}


		protected override void init(double xx,double yy,int option){

			x=Math.Floor(xx / manager.BlockWidth ) * manager.BlockWidth;
			y=Math.Floor(yy / manager.BlockHeight) * manager.BlockHeight;
			Z=Zindex.EnemyZ;

			attackRate = EnemyParameter.Cannon_attackRate;
			attackCounter=manager.M(attackRate);
			
			imgWalk  = getImageID(EnemyParameter.Cannon_imgWalk);
			imgDie   = imgWalk;
			Face     = imgWalk;
			
			charBodyWidth    = (int)Math.Round(manager.BlockWidth);
			charBodyHeight   = (int)Math.Round(manager.BlockHeight);
			charSpriteWidth  = charBodyWidth;
			charSpriteHeight = charBodyHeight+3;
//			verticalAlign    = Valign.Middle;

			manager.SetXYPointObject(x,y,Blocks.HardBlock,WriteMode.Ram);

			MoveTo(x,y);
			SetSize();
		}

	//----------------------
		public override bool Action(){
		  if(alive<0)return false;
		  if(manager.CheckScreen(this)< 0)return false;
		 innerTimer++;

			Player p=manager.GetPlayerObject();
			  if( x < p.X )HFace=1;
			  else HFace=-1;
			  
			  if(attackCounter <= 0 && 
			  	EnemyParameter.LiveCannonCnt < EnemyParameter.LiveCannonMax
			  ){
				manager.CreateEnemy(CharCode.CannonBall,x,y,HFace);
				attackCounter=manager.M(attackRate)+50;
		//		manager.DBGn("next="+attackCounter);
			  }

			double pl=p.X,pr=p.X+p.Width;
			double dp=charBodyWidth+3;

			if( x <= pr + 2 && x+charBodyWidth >= pl - 2 ){
				attackCounter=manager.M(attackRate)+10;
			}

			  attackCounter--;

			 return true;
		}

	//----------------------
		public override bool OnCollision(MCharacter obj){
			return false;
		}


	}
}