namespace mylib{
	using System.Drawing;
	using System;
	using mylib;
	
	class CannonBall: Chubo{
		private int imgWalk2=0;
		private bool calledEnemy=true;

		public CannonBall(StageManager E,double xx,double yy,int code,int option)
			:base(E,xx,yy,code,option){
		}


		protected override void init(double xx,double yy,int option){

			screenDrop=true;
			xAccel=0;
			yAccel=0;
			xMove=-4;
			 hasGroupCollision=false;
			 checkWall=false;
			 checkFloor=false;
			 checkStage=false;
			 Z=Zindex.BasicZ-1;
//			verticalAlign=Valign.Middle;
			
			
			switch(charCode){
			 case mylib.CharCode.CannonBall:
				 imgWalk=getImageID(EnemyParameter.CannonBall_imgWalk);
				 imgDie=imgWalk;
				 charSpriteWidth =32;
				 charSpriteHeight=32;
				 charBodyWidth   =24;
				 charBodyHeight  =24;
				 y+=3;
				 registKick  = 2;
				 registFire  = 1;
				 registUpper = 2;
				 xAccel=.05;
				 if(manager.M(128)==64){ // AX^[ Ƃ܌N
				  score*=20;
				  imgWalk=getImageID(EnemyParameter.Toriyama_imgWalk);
				  imgDie=imgWalk;
				  xMove=-6;
				  xAccel=-.1;
				 }
			 break;
			 case mylib.CharCode.Sakana:
				 score=400;
				 checkFloor=false;
				 checkWall=false;
				 checkStage=false;
				 xMove=-2;
				 yMove= (manager.M(1000)*.01 -5)/4;
				 xAccel=0;
				 yAccel=0;
				 hasGroupCollision=false;
				 imgWalk=getImageID(EnemyParameter.Sakana_imgWalk);
				 imgDie=imgWalk;

				 if(manager.M(10)>=7){
					 imgWalk=getImageID(EnemyParameter.Sakana2_imgWalk);
					 imgDie=imgWalk;
					xMove*=1.2;
				 }
			 break;
			 case mylib.CharCode.Tobiuo:
				 score=400;
				 xMove=-6-manager.M(400)*.01;
				 yMove=-21.5-manager.M(800)*.01;
				 yAccel=1;
				 checkFloor=false;
				 checkWall=false;
				 checkStage=false;
				 hasGroupCollision=false;

				 imgWalk=getImageID(EnemyParameter.Sakana_imgWalk);
				 imgDie=imgWalk;
			//	 manager.DBG("Tobiuo\n");
			break;
			 case mylib.CharCode.Ika:
				 score=400;
				 checkFloor=false;
				 checkWall=false;
				 checkStage=false;
				 xMove= -4;
				 yMove= 3;
				 hasGroupCollision=false;
				 imgWalk  =getImageID(EnemyParameter.Ika_imgWalk);
				 imgWalk2 =getImageID(EnemyParameter.Ika_imgWalk2);
				 imgDie=imgWalk;
			break;
			case mylib.CharCode.Tamago:
				 screenDrop=true;
				 checkFloor=true;
				 checkStage=true;
				 score=200;
				 registPress=1;
				 xMove=xAccel=0;
				 yMove=-15.1;
				 yAccel=1.5;
				 ySpeedMax=10;
				 imgWalk = getImageID(EnemyParameter.Tamago_imgWalk);
				 imgDie  = getImageID(EnemyParameter.Tamago_imgDie);
			break;
			 default:
			 case mylib.CharCode.KamezoBreath:

				imgWalk=getImageID(EnemyParameter.KamezoBreath_imgWalk);
				imgDie=imgWalk;
				 registPress=2;
				 charSpriteWidth=48;
				 charSpriteHeight=24;
				 charBodyWidth=32;
				 charBodyHeight=8;
				 registKick  = 2;
				 registFire  = 1;
				 registUpper = 2;

			 break;
			}

			Face=imgWalk;

			//܂ꂽ_ŉʊOXe[Wɖߍ܂ꂽGl~[Ɣf(蔲)
			if(manager.CheckScreen(this)<0){
				screenDrop=false;
				calledEnemy=false;
				Player p=manager.GetPlayerObject(0);
				if(p.X<x){
					option=-1;
				}
			}



			if(calledEnemy){
				inc();
//				manager.DBGn("ADD"+EnemyParameter.LiveCannonCnt+" ID="+id);
			}else{
//				manager.DBGn("normal");
			}


			 if(option >0){
				xMove =  Math.Abs(xMove);
				xAccel=  Math.Abs(xAccel);
				HFace =  1;
			 }else{
				xMove = -Math.Abs(xMove);
				xAccel= -Math.Abs(xAccel);
				HFace = -1;
			}


			SetSize();
			
		}






		private void inc(){
			EnemyParameter.LiveCannonCnt+=1;
		}
		private void dec(){
			if(EnemyParameter.LiveCannonCnt>0)
				EnemyParameter.LiveCannonCnt-=1;
		}




	//----------------------
		public override bool Action(){
		  if(alive<0)return false;
		  if(manager.CheckScreen(this)< 0){
			if(screenDrop)Kill(KillMode.Drop);
			return false;
			}
		 innerTimer++;
			basicMove();

			Player p=manager.GetPlayerObject(0);

		 switch(charCode){
			case mylib.CharCode.Tamago:
			  if(yMove==0){
				HFace=(x > p.X) ? -1 : 1;
				manager.CreateEnemy(CharCode.Toge,x,y,-1);
				Kill(KillMode.Drop);
			  }
			break;
			case mylib.CharCode.Ika:
			 int cp=innerTimer%30;
			 if(cp==0){
				xMove=((x > p.X) ? -4 : 4);
				yMove=-5-manager.M(5);
			 }else
			 if(cp==10){
				xMove=0;
				yMove=5+manager.M(5);
			 }
			 if(cp<=15){
				Face=imgWalk2;
			 }else{
				xMove=0;
				yMove=2;
				Face=imgWalk;
			 }
			 goto case mylib.CharCode.Sakana;
//			break;
			case mylib.CharCode.Sakana:
			 if(y<manager.ScrollTop+manager.BlockHeight*1){
					yMove=Math.Abs(yMove);
					y+=yMove;
			 }
			 else
			 if(y>manager.ScrollTop+manager.VirtualHeight-manager.BlockHeight*2.5){
					yMove=-Math.Abs(yMove);
					y+=yMove;
			}
			break;
		 }


		 return true;
		} //




	//----------------------
		
		public override int Kill(){return Kill(KillMode.Other);}
		public override int Kill(KillMode kmode){
		 if(alive<0)return -1;

		  if(calledEnemy){
//			manager.DBGn("DEL"+EnemyParameter.LiveCannonCnt);
			dec();
		  }
		  switch(kmode){
			case KillMode.Drop:
			break;
			case KillMode.Star:
			case KillMode.Upper:
			case KillMode.Fire:
			case KillMode.Kick:
			{
			 MCharacter dd=manager.CreateEffect(CharCode.DyingEffect,x,y,0);
			 dd.SetMaster(this);
			}
			break;
			case KillMode.Press:
			 {
			 MCharacter dd=manager.CreateEffect(CharCode.DyingEffect,x,y,0);
			 dd.SetMaster(this);
			 dd.XMove=0;
			 dd.YMove=0;
			 if(charCode==mylib.CharCode.CannonBall)dd.VFace=1;
			 }
			break;
		  }
		  return base.Kill(KillMode.Drop);
		}


		protected override bool stepCollision(MCharacter m){
	//	 if(ENV.STAGEMODE==WATER)
		 if(m is Player ){
			if(((Player)m).ActionMode==ActionMode.Swim)return false;
		 }
		 if(charCode==mylib.CharCode.Ika || charCode==mylib.CharCode.Tobiuo){
			if((m.YMove>5) && (yMove<10))return true; // ђʂă_[WɂȂĂ܂΍
		 }
		 return base.stepCollision(m);
		}




















	}
}