namespace mylib{
	using System.Drawing;
	using System;
	using mylib;
	
	public class DyingCharacter: EffectObject{
		private ObjGroup masterGroup;

		public DyingCharacter(StageManager E,double xx,double yy,int code,int option)
			:base(E,xx,yy,code,option){
		}


		protected override void init(double xx,double yy,int option){
		}

		public override void SetMaster(MCharacter m){
		  master=m;
		  masterGroup=master.Group;
		 // sprite.setBitmap(m.imgDie);
		  Face=m.ImgDie;
		  HFace=master.HFace;
		  charBodyWidth  = master.Width;
		  charBodyHeight = master.Height;
		  charSpriteWidth  = master.SpriteWidth;
		  charSpriteHeight = master.SpriteHeight;
		  x=master.X;y=master.Y;z=master.Z;
		  
		  if(HFace==0){
			HFace=1;
		  }

		  if(master.Peta){
			actionCnt=10;
			charSpriteHeight/=2;
			SetSize();
			xMove=0;
			yMove=0;
			yAccel=0;
			MoveTo(x,y);
			hasGroupCollision=true;
		  }else{
			actionCnt=80;
			SetSize();
			VFace=-1;
			xMove=master.XMove;
			 if(Math.Abs(xMove)<=1.0 || Math.Abs(xMove)>6.0)xMove=4*HFace;
			yMove=-18;
			yAccel=2;
			MoveTo(x,y);
			hasGroupCollision=false;
		  }
		}


	//----------------------
		public override bool Action(){
			 if(alive<0)return false;
			 innerTimer++;
			  xMove+=xAccel;
			  yMove+=yAccel;
			  x+=xMove;
			  y+=yMove;
			  if(hasGroupCollision)masterGroup.GroupCollision(this);
		  if(innerTimer>actionCnt)Kill(KillMode.Other);
		 return true;
		}

		public override bool OnCollision(MCharacter obj){
		 if(alive<0)return false;
		 if(!hasGroupCollision)return false;
		  if(obj.Mind == mylib.Mind.Enemy){
		    if(obj.HasGroupCollision){
			 if(x >= obj.X)
				obj.XMove=-Math.Abs(obj.XMove);
			 else
				obj.XMove= Math.Abs(obj.XMove);
		    }

		  }
		  return true;
		}



	}


}