namespace mylib{
	using System.Drawing;
	using System;
	using mylib;
	
	class GoalFlag: MCharacter{

		public GoalFlag(StageManager E,double xx,double yy,int code,int option)
			:base(E,xx,yy,code,option){
		}


		protected override void init(double xx,double yy,int option){
			mind=Mind.Other;
			
			charBodyWidth  = 48;
			charBodyHeight = 32;
			charSpriteWidth  = 48;
			charSpriteHeight = 32;
			z=Zindex.StageZ-1;
			yMove=10;
			
			imgWalk=getImageID(EnemyParameter.GoalFlag_imgWalk);
			Face=imgWalk;

			Set(x,y,false,null);
			MoveTo(x,y);
		}
//----------------------
		public void Set(double xx,double yy,bool v,ObjGroup group){
			x=xx-charBodyWidth+manager.BlockWidth*.5;
			y=yy+manager.BlockHeight*.5;
			SetSize();
			MoveTo(x,y);
			Visible=v;
			if(group!=null)GroupEntry(group);
//			manager.DBGn("GOALFLAG SET! x="+x+" y="+y+" xx="+xx+" yy="+yy);
		}
		public void Reset(){
			Visible=false;
			x = -manager.VirtualWidth  * 10;
			y = -manager.VirtualHeight * 10;
		}

	//----------------------
		public override bool Action(){
			innerTimer++;
			Face=imgWalk;
			
			return true;
		}
	//----------------------
		public override bool OnCollision(MCharacter obj){
			return false;
		}
	//----------------------
		public override int Kill(){return 1;}
		public override int Kill(KillMode Kmode){return 1;}



	}


}