namespace mylib{
	using System.Drawing;
	using System;
	using mylib;
	
	class GoldenAxe: MCharacter{
		//private double oldScrollXmax;
		private bool animateFlag=false;
		private int animateCounter=0;
		private int animateCounterStart=1000;
		private int hatenaWait=20;
		private double xm;
		private bool mflag=false;

		public GoldenAxe(StageManager E,double xx,double yy,int code,int option)
			:base(E,xx,yy,code,option){
		}


		protected override void init(double xx,double yy,int option){
			score=5000;
			
			imgWalk = getImageID(EnemyParameter.GoldenAxe_imgWalk);
			imgDie  = imgWalk;
			Face    = imgWalk;


			x=Math.Floor(xx / manager.BlockWidth  ) * manager.BlockWidth;
			y=Math.Floor(yy / manager.BlockHeight ) * manager.BlockHeight;
			//Z=Zindex.BasicZ;

				charBodyWidth  = 16;	//蔻TCY
				charBodyHeight = 16;
				charSpriteWidth  = 32; //OtBbÑTCY
				charSpriteHeight = 32;




			//oldScrollXmax=manager.ScrollXmax;


			manager.SetGoldenAxe(this);
			x+=cSprX;
			y+=cSprY;
			xm=x;

			SetSize();
		}






//----------------------
		public override bool Action(){
		  if(alive<0)return false;

//		   if(manager.ScrollLeft > x+charBodyWidth-manager.VirtualWidth)
		   if(Math.Abs(manager.ScrollLeft+manager.VirtualWidth-(x+charBodyWidth))<manager.BlockWidth/2){
		   		manager.ScrollLeft = x+charBodyWidth-manager.VirtualWidth;
		   		manager.ScrollLock=true;
		   }

		  if(!animateFlag)return false;
		  innerTimer++;
		   if(animateCounter % 2==0 && animateCounter>hatenaWait){
			xm-= manager.BlockWidth;
			if(xm>manager.ScrollLeft+manager.BlockWidth){
				manager.SetXYPointObject(xm,y+manager.BlockHeight*2,Blocks.Blank);
				//manager.CreateMessage("h",xm,y+manager.BlockHeight*2);//.sprite.font=manager.infoFont;
			}
			else	animateCounter=hatenaWait+1;
		
		   }else
		   if(animateCounter==hatenaWait){
			MCharacter k=manager.GetBoss();
			if(k!=null){
			 if(k.Alive>0){
				  manager.CreateMessage("! ?",k.X,k.Y);
			 }
			}
			
		   }else
		   if(animateCounter==0){
			MCharacter m=manager.GetBoss();
			if(m!=null){
			 if(m.Alive>0){
				m.Kill(KillMode.Drop);
			 }
			}
		   }
		  
		  if(animateCounter--<=0){Kill(KillMode.Drop);return true;}
			return true;

		}

		public override bool OnCollision(MCharacter m){
		  if(master==m)return false;
		  if(m.Mind!=mylib.Mind.Player)return false;
		  if(mflag)return false;
			m.GetScore(score);
			m.XMove=0;
			if(m.YMove<-3)m.YMove=-3;
			animateCounter=animateCounterStart;
			animateFlag=true;
			xm=x;
			mflag=true;
			SetMaster(m);
		   ((Player)m).SetAnimMaster(this,animateCounterStart);

		   return true;
		}


		public override int Kill(){return Kill(KillMode.Other);}
		public override int Kill(KillMode kmode){
		 if(alive<0)return -1;
			if(master!=null)((Player)master).Axe();
			manager.ScrollLock=true;
			manager.KillGoldenAxe();

		  return base.Kill(kmode);
		}






	}
}