namespace mylib{
	using System.Drawing;
	using System;
	using mylib;
	
	class Hammer: Chubo{
		public Hammer(StageManager E,double xx,double yy,int code,int option)
			:base(E,xx,yy,code,option){
		}


		protected override void init(double xx,double yy,int option){

			xAccel = 0;
			xMove  = EnemyParameter.HammerObject_xMove;
			
			yAccel = EnemyParameter.HammerObject_yAccel;
			yMove  = EnemyParameter.HammerObject_yMove;
			ySpeedMax=EnemyParameter.HammerObject_ySpeedMax;

			imgWalk = getImageID(EnemyParameter.HammerObject_imgWalk);
			imgDie=imgWalk;
			Face=imgWalk;
			
			charBodyWidth  = 8;
			charBodyHeight = 8;
			charSpriteWidth  = 16;
			charSpriteHeight = 16;
			verticalAlign=Valign.Middle;

			if(option<0){
				xMove=-Math.Abs(xMove);
			}


			SetSize();
		}



//----------------------
		public override bool Action(){
		  if(alive<0)return false;
		  if(manager.CheckScreen(this)< 0){Kill(KillMode.Drop);return false;}
			 innerTimer++;

			  xMove+=xAccel;
			  yMove+=yAccel;
			  if(yMove>ySpeedMax)yMove=ySpeedMax;

			  x+=xMove;
			  y+=yMove;
		 return true;
		}

		public override bool OnCollision(MCharacter obj){// sg
		 if(alive<0)return false;
		 if(obj.Alive<0)return false;
		 if(manager.CheckScreen(this) < 0)return false;
		  switch(obj.Mind){
			case mylib.Mind.Player:
				obj.Damage(this);
				if(!((Player)obj).Ghost)manager.CreateMessage("GA!!",x,y);
			break;
			default:
			break;
		  }
		 return true;
		}
		public override bool Collision(MCharacter obj){
			if(obj.Mind != mylib.Mind.Player)return false;
			return base.Collision(obj);
		}








	}
}