namespace mylib{
	using System.Drawing;
	using System;
	using mylib;
	
	public class JumpBlock: MCharacter{
		private int animateCounter;
		 public int AnimateCounter{
			get{return animateCounter;}
		 }
		private const int aCounterStart=8;
		private bool catching=false;

		public JumpBlock(StageManager E,double xx,double yy,int code,int option)
			:base(E,xx,yy,code,option){
		}


		protected override void init(double xx,double yy,int option){
			oldX=x;
			oldY=y;

			hasGroupCollision=false;
			catching=false;

			charBodyWidth  = (int)Math.Floor(manager.BlockWidth);
			charBodyHeight = (int)Math.Floor(manager.BlockHeight*2);
			charSpriteWidth  = (int)Math.Floor(manager.BlockWidth);
			charSpriteHeight = (int)Math.Floor(manager.BlockHeight*2);
				 cSprX=(charSpriteWidth  - charBodyWidth  ) / 2;
				 cSprY=(charSpriteHeight - charBodyHeight ) / 2;
			
			x=Math.Floor( x / manager.BlockWidth  ) * manager.BlockWidth;
			y=Math.Floor( y / manager.BlockHeight -1) * manager.BlockHeight;
			Z=Zindex.StageZ-1;

			imgWalk=getImageID(EnemyParameter.JumpBlock_imgWalk);
			imgDie=imgWalk;
			Face=imgWalk;


			SetSize();
			manager.SetXYPointObject(x,y,Blocks.Blank);

		}






//----------------------
		public override bool Action(){
		  if(alive<0)return false;
		  if(manager.CheckScreen(this)< 0)return false;
		 innerTimer++;
		 Player p=manager.GetPlayerObject(0);

		  if(catching!=true && animateCounter<=0){
		   if(Collision(p)){
			 bool h = stepCollision(p);
			 if(h){
				animateCounter=aCounterStart;
				catching=true;
				p.ResetJumpBonus();
			}else{
			 if(p.X+p.Width/2 > x+charBodyWidth/2){
				p.X=x+charBodyWidth;
				if(p.XMove<0)p.XMove=0;
			 }
			 else{
				p.X=x-p.Width;
				if(p.XMove>0)p.XMove=0;
			 }
			 catching=false;
			}
		   }else{
			 catching=false;
		   }
		  }
	  

		// ܂X}[gȂ
		  if(animateCounter>0){
			int am=animateCounter; //
			int amm=aCounterStart/2; //4


			if(am > amm )am = amm - (am % amm);
			 if(am > 3)am=3;
			 int ams=am*am*5;
			 charSpriteHeight=charBodyHeight-ams;
			 SetSize();


			if(catching){
				double jump=10.1+9*(am+1);
				p.CatchJumpBlock(this,jump);
			}
		  }
		  if(animateCounter==0){
			if(catching){
				p.ReleaseJumpBlock(this);
			}
			 charSpriteHeight=charBodyHeight;
			 SetSize();
			catching=false;
		  }

		animateCounter--;

		 return true;

		}

		public void ReleasePlayer(){
			catching=false;
		}






	}
}