namespace mylib{
	using System.Drawing;
	using System;
	using mylib;
	
	class Kame: Chubo{
		protected int imgSleep;
		protected int imgWake;
//		private bool katochan=false;
		private int sleepCounter=0;
		private int sleepCounterStart=EnemyParameter.KameSleepTime;
		private int ghostCounter=0; // R̓蔻
		private const int ghostCounterStart=8;
//		private int kCounter=0;
		private double xMoveDefault=2;
		private bool checkFloorDefault;
		private double kickXMove=EnemyParameter.KameKickSpeed;
		private int kameType=CharCode.KameGR;
		 private const  int kameWalk  = 0;
		 private const int kameKick  = 1;
		 private const int kameSleep = 2;

		private int walkmodeYAccel=6;
		private int kickmodeYAccel=6;
		private int kameMode=kameWalk;
		
		private int kickBonus=0;

		public Kame(StageManager E,double xx,double yy,int code,int option)
			:base(E,xx,yy,code,option){
		}


		protected override void init(double xx,double yy,int option){
			charSpriteHeight=38;//Ƃw


			string iWalk,iSleep,iDie,iWake;
			switch(charCode){
				default: goto case mylib.CharCode.KameGR;
				case mylib.CharCode.KameGR:
				 iWalk  = EnemyParameter.KameGR_imgWalk;
				 iSleep = EnemyParameter.KameGR_imgSleep;
				 iDie   = EnemyParameter.KameGR_imgDie;
				 iWake  = EnemyParameter.KameGR_imgWake;
				 score=200;
				break;
				case mylib.CharCode.KameRD:
				 iWalk  = EnemyParameter.KameRD_imgWalk;
				 iSleep = EnemyParameter.KameRD_imgSleep;
				 iDie   = EnemyParameter.KameRD_imgDie;
				 iWake  = EnemyParameter.KameRD_imgWake;
				 score=200;
				 checkFloor=true;
				break;
				case mylib.CharCode.KameBK:
				 int rnd=manager.M(100);
				   score=400;
				  if(rnd==64){ //AX^[
				   iWalk  = EnemyParameter.KameK_imgWalk;
				   iSleep = EnemyParameter.KameK_imgSleep;
				   iDie   = EnemyParameter.KameK_imgDie;
				   iWake  = EnemyParameter.KameK_imgWake;
					score*=10;
//					stepScore*=2;
				   checkFloor=true;
				  }else{
				   iWalk  = EnemyParameter.KameBK_imgWalk;
				   iSleep = EnemyParameter.KameBK_imgSleep;
				   iDie   = EnemyParameter.KameBK_imgDie;
				   iWake  = EnemyParameter.KameBK_imgWake;
				  }
				   registFire=1;
				break;
			}
			imgWalk  = getImageID(iWalk);
			imgSleep = getImageID(iSleep);
			imgDie   = getImageID(iDie);
			imgWake  = getImageID(iWake);


			Face=imgWalk;

			checkFloorDefault=checkFloor;
			kameType = charCode;
			kameMode = kameWalk;
			charCode = kameType;



			//xMoveDefault=xMove;

			SetSize();
		}

	//----------------------
		public override bool Action(){
		  if(alive<0)return false;
		  if(manager.CheckScreen(this)< 0){
			if(kameMode==kameKick)SetKameMode(kameWalk);
			return false;
		  }
		 innerTimer++;
//		  if(hasGroupCollision)myGroup.groupCollision(this);
//		  if(alive<0)return false;
		  basicMove();


		  switch(kameMode){
			case kameWalk:
			 HFace=(int)Math.Round(xMove/Math.Abs(xMove));
			 Face=imgWalk;
			break;
			case kameSleep:
			 if(xMove!=0)sleepCounter=sleepCounterStart;
			 if(yMove==0)xMove=0;
			 
			 if(sleepCounter<64)Face=imgWake;
			 else	Face=imgSleep;

			 if(sleepCounter--<=0)SetKameMode(kameWalk);
			break;
			case kameKick:
			 Face=imgSleep;
			break;
		  } //


		  ghostCounter--;

		 if(dropKillCheck()){Kill(KillMode.Drop);return false;}
		 return true;


		}
		public int SetKameMode(int mm){
		  switch(mm){
			case kameSleep:
				if(kameMode==kameWalk)xMoveDefault=xMove;
				kameMode=kameSleep;
				mind=mylib.Mind.Enemy;
				sleepCounter=sleepCounterStart;
				xMove=0;
				yMove=0;
				yAccel=walkmodeYAccel;
				kickBonus=0;
				checkFloor=false;
				hasGroupCollision=true;
			break;
			case kameKick:
				kameMode=kameKick;
				mind=mylib.Mind.Kick;
				checkFloor=false;
				yAccel=kickmodeYAccel;
	//			hasGroupCollision=false;
			break;
			case kameWalk:
				kameMode=kameWalk;
				mind=mylib.Mind.Enemy;
				xMove=xMoveDefault*hFace;
				yAccel=walkmodeYAccel;
				checkFloor=checkFloorDefault;
//				sprite.setFlipV(false);
				VFace=1;
				kickBonus=0;
				hasGroupCollision=true;
			break;
		  }
	//	 ENV.DBGn("mindC="+mind+ "mm="+mm);
		 return kameMode;
		} //



		public void ConvertKame(MCharacter m,int upperFlag){
		//	switch(m.CharCode){
		//		case CharCode.Pata:
		//		case CharCode.PataV:
		//		case CharCode.PataH:
		//		break;
		//	}
//			xMove=xMoveDefault*m.HFace;
			x=m.X;
			y=m.Y;
			HFace=m.HFace;
			ghostCounter=3;
			if(upperFlag >0){
			//	manager.DBG("UPPER!");
				VFace=-1;
				SetKameMode(kameSleep);
				yMove=-yBounce;
			}
			return;
		}







		public override int GetKickBonus(){
		 if(master==null){manager.DBG("error kickbonus");return 0;}
			int b=master.GetBonus(kickBonus++);
			if(b==ItemCode.IgetNum){
			 master.GetItem(ItemCode.Iget);
			 manager.CreateMessage("+ 1GET +",x,y);
			}else{
			 manager.CreateMessage(""+b,x,y);
			}
			return b;
		} //
	//----------------------
		public override bool OnCollision(MCharacter obj){
		 if(alive<0)return false;
	//	 if(obj.alive<0)return false;
		 if(manager.CheckScreen(this) < 0)return false;

		  switch(obj.Mind){
		   case mylib.Mind.Enemy:
		    if(!hasGroupCollision || !obj.HasGroupCollision)break;
			if(kameMode==kameWalk){
				xMove*=-1;
			 if(x >= obj.X)
				xMove= Math.Abs(xMove);
			 else
				xMove=-Math.Abs(xMove);
			}
		   break;
		   case mylib.Mind.Kick:
				if(registKick>0)break;
			 if(mind==mylib.Mind.Kick){
				if(obj!=null){ // ł΍
				 GetScore(score);
				// getKickBonus();
				}
			 }else{
				 obj.GetScore(score);
				 obj.GetKickBonus();
			 }
				Kill(KillMode.Kick);
		   break;
		   case mylib.Mind.Upper:
			if(kameMode==kameSleep){ //{[iX֌W
				if(sleepCounter < 64){
					int c=(int)((64-sleepCounter-1)/8);
					int b=obj.GetBonus(c);
					manager.CreateMessage(""+b,x,y);
				}
			}
			SetKameMode(kameSleep);
			obj.GetScore(score);
			VFace=-1;
			 yMove=-yBounce;
			 if(x>obj.X)	xMove =  Math.Abs(xMoveDefault);
			 else		xMove = -Math.Abs(xMoveDefault);

		   break;
		   case mylib.Mind.Player:
			if(((Player)obj).Star == true){
				obj.GetStarBonus();
				Kill(KillMode.Star);
				break;
			}else{
			 if(ghostCounter>0)break;



			 bool h = stepCollision(obj); // ݂
			 if(kameMode==kameSleep){
				SetMaster(obj);

				SetKameMode(kameKick);
				 if(x>obj.X)	xMove =  kickXMove;
				 else		xMove = -kickXMove;
				x+=xMove;

				if(sleepCounter < 64){
					int c=(int)((64-sleepCounter-1)/8);
					int b=obj.GetBonus(c);
					manager.CreateMessage(b.ToString(),x,y);
				}


				ghostCounter=ghostCounterStart;

				break;
			 }else
			 if(h){ // PRESS
				ghostCounter=ghostCounterStart/2;
				obj.StepEnemy(this);
				SetKameMode(kameSleep);
			 }else{ // 
			  //isAb̌ɃvC[ꍇ
			  //(܂ɒǂĂ܂΍)
			   if(kameMode==kameKick){
			    if(xMove*obj.XMove>0){
			     if(  ((obj.X-x< -20) && ( obj.XMove> 10 )) ||
			          ((obj.X-x>  20) && ( obj.XMove<-10 ))
			       ){
				break;
			      }
			     }
			    }
				obj.Damage(this);
			 }
			}
		   break;
		   default:
		    return base.OnCollision(obj);
//		   break;
		  }
			return true;
		}

	}


}