namespace mylib{
	using System.Drawing;
	using System;
	using mylib;
	
	class Kumozo: Chubo{
		private double firstX;
		private double firstY;
		private int attackRate;
		private int attackCounter;
		private int sleepCounter;
		private int sleepTime;
		private int animateCounter;

		public Kumozo(StageManager E,double xx,double yy,int code,int option)
			:base(E,xx,yy,code,option){
		}


		protected override void init(double xx,double yy,int option){
			xMove=2;
			yMove=0;
			yJump=0;
			yAccel=0;


			score     = 1000;

			attackRate = 100;
			attackCounter=manager.M(attackRate);
			sleepCounter = 0;
			sleepTime  = 50;
			animateCounter = 0;


			x=Math.Floor(xx/manager.BlockWidth ) * manager.BlockWidth;
			y=Math.Floor(yy/manager.BlockHeight) * manager.BlockHeight;

			firstX=x;firstY=y;// ʒu𕜊|Cgɂ

			x = manager.ScrollLeft + manager.VirtualWidth*.5;


			registFire  = -1; //
			registUpper = -1; //
			registKick  = -1; //
			registPress = -1; //
			hasGroupCollision=false;

			charBodyWidth =24;
			charBodyHeight=24;
			charSpriteWidth =32;
			charSpriteHeight=48;
			verticalAlign=Valign.Middle;

			imgWalk = getImageID(EnemyParameter.Kumozo_imgWalk);
			imgDie  = getImageID(EnemyParameter.Kumozo_imgDie);
			Face=imgWalk;


			 SetSize();
		}






//----------------------
		public override bool Action(){
		  if(alive<0)return false;
		  //if(ENV.isScreen(this)< 0)return false;
		  if(--sleepCounter>0)return false;
		 innerTimer++;
		  int iscreen=manager.CheckScreen(this);
		  int oscreen=manager.CheckScreen(firstX,firstY,charBodyWidth,charBodyHeight);
		  Player p=manager.GetPlayerObject(0);


		 // ň莞Ԃ畜邪A|Cgʓɂ畜Ȃ
		  if(sleepCounter==0){
			if(oscreen < 0){
				x=firstX;
				MoveTo(x,y);
				Visible=true;
			}else
				Kill(KillMode.Drop);
				return false;
		  }


		  if(innerTimer%50==0){
			xMove=Math.Abs(xMove);
			if(x>p.X)xMove*=-1;
		  }
		  if(firstX < p.X){
			xMove=-8;
		  }


		  if(iscreen < 0){
			x+=xMove*10;
		  }else{
			if(manager.GameStage.LeftScroll  && p.XCameraControl<0)x+=p.XCameraControl;
			if(manager.GameStage.RightScroll && p.XCameraControl>0)x+=p.XCameraControl;
			x+=xMove;
			y+=yMove;

			
			if(attackCounter--<=0){
				if(EnemyParameter.LiveCannonCnt < EnemyParameter.LiveCannonMax)
						manager.CreateEnemy(CharCode.Tamago,x,y,0);
				attackCounter=manager.M(attackRate)+10;;
			}
		  }
			animateCounter--;

		 return true;

		}



		public override int Kill(){return Kill(KillMode.Other);}
		public override int Kill(KillMode kmode){
		  if(alive<0)return -1;
			Visible=false;
		  switch(kmode){
			case KillMode.Drop:
			break;
			case KillMode.Star: goto case KillMode.Press;
			case KillMode.Upper: goto case KillMode.Press;
			case KillMode.Fire: goto case KillMode.Press;
			case KillMode.Kick: goto case KillMode.Press;
			case KillMode.Press:
			 sleepCounter=sleepTime;
			  MCharacter dd=manager.CreateEffect(CharCode.DyingEffect,x,y,0);
			  dd.SetMaster(this);
			  dd.XMove=xMove;
			  x=-100;
			 return -1;
		  }
		//  EnemyParameter.LiveCannonCnt=0;
		  return base.Kill(KillMode.Drop);
		}






	}
}