namespace mylib{
	using System.Drawing;
	using System;
	using mylib;
	
	class TenCoinBlock: MCharacter{
		private int blockCode=1;
		private int maxcnt=30*4;

		public TenCoinBlock(StageManager E,double xx,double yy,int code,int option)
			:base(E,xx,yy,code,option){
		}


		protected override void init(double xx,double yy,int option){

			x=Math.Floor(xx / manager.BlockWidth ) * manager.BlockWidth ;
			y=Math.Floor(yy / manager.BlockHeight) * manager.BlockHeight ;
			Z=Zindex.StageZ+1;
			xMove=0;
			yMove=-8;
			xAccel=0;
			yAccel=2;
			charBodyWidth  = (int)Math.Floor(manager.BlockWidth);
			charBodyHeight = (int)Math.Floor(manager.BlockHeight);
			charSpriteWidth  = (int)Math.Floor(manager.BlockWidth);
			charSpriteHeight = (int)Math.Floor(manager.BlockHeight)-1;
			verticalAlign=Valign.Middle;
			SetSize();
			

			 Visible=true;
			 x+=cSprX;

			 blockCode=option;
			 string str=manager.GetBlockImageName(option);
			 imgWalk=getImageID(str);
			 Face=imgWalk;



		}






//----------------------
		public override bool Action(){
			innerTimer++;

			if(innerTimer>maxcnt){Kill();return false;}
			return true;
		}



		public override bool OnCollision(MCharacter m){
			 if(alive<0)return false;
			 if(m.Mind!=mylib.Mind.Player)return false;
			    if(m.YMove < 0 && m.Y > y ){
				((Player)m).GetItem(ItemCode.Coin);
				MCharacter dd=manager.CreateObject(CharCode.Bounce,x,y,blockCode);
				dd.SetMaster(m);
				manager.CreateEffect(CharCode.BounceCoinEffect,x,y,0);
				m.Y=y+charBodyHeight;
				m.YMove=.1;
			    }
			return true;
		}



		public override int Kill(){return Kill(KillMode.Other);}
		public override int Kill(KillMode kmode){
		 if(alive<0)return -1;
			manager.SetXYPointObject(x,y,Blocks.HiddenCoinBlockA,WriteMode.All);
		  return base.Kill(kmode);
		}






	}
}