namespace mylib{
	using System.Drawing;
	using System;
	using mylib;

	class TitleScreen{
		private EnvManager env;
		public int innerTimer =0;
//		private int mode=0;
//		private int nextMode=0;


//		private int waitTimer=0;
		private int mozaic=30;
		 public int Mozaic{
			get{return mozaic;}
		 }

		private Font infoFont;
		private Font logoFont;
		private Font smallFont;

//		private Font tmpFont;
//		private Color tmpColor;

		private Sprite spr;


		private GamePad pad;
		
		private bool initFlag=false;

		private Sprite logo;

		private Player pl;

		private string[] stage=	{
					"stage1-1.txt",
					"stage1-2.txt",
					"stage1-3.txt",
					"stage1-4.txt",

					"stage2-1.txt",
					"stage2-2.txt",
					"stage2-3.txt",
					"stage2-4.txt",

					"stage3-1.txt",
					"stage3-2.txt",
					"stage3-3.txt",
					"stage3-4.txt",

					"stage4-1.txt",
					"stage4-2.txt",
					"stage4-3.txt"

					};

		public TitleScreen(EnvManager E,GamePad P){
			env=E;
			pad=P;
//			nextMode=EnvManager.Gaming;

			
			spr  = new Sprite(E,0,0);
			logo = new Sprite(E,0,0);
			logo.BitmapImageName="img/logo.gif";
			logo.SetSize(384,150);
			logo.Visible=true;
			logo.Opacity=0.8;
			logo.Z=150;
		}
		private void resetFont(){
			float w=(float)env.ScreenWidth;
			float h=(float)env.ScreenHeight;
			infoFont=new Font("lr SVbN",h/25,FontStyle.Bold);

			logoFont=new Font("Impact",h/20,FontStyle.Bold);

			smallFont=new Font("lr SVbN",h/35,FontStyle.Bold);
		}


		private int ptr=0;
		private double xMove=3;

		private MCharacter mm;
		private MCharacter mm2;
		private MCharacter mm3;
		private MCharacter mm4;
		public void init(){
			if(infoFont==null)resetFont();
			ptr=0;
			nextStage();
			env.Mozaic=0;
			pad.Reset();
			env.ClsFlag=true;

			pl=env.GetPlayerObject();
//			env.DBGn("initialize titledemo ");
			pl.Visible=false;
		 initFlag=true;
		}


		public void nextStage(){
			env.ScrollLeft=0;
			env.ScrollTop=0;
			env.Enemies.Clear();
			env.Others.Clear();
			env.Effects.Clear();
			env.LoadStage(stage[ptr]);
			env.SetVirtualScreenSize(512,424);
			env.CreateStageObjects();


			mm=env.CenterMessage("PRESS ANY BUTTON",430,3000,logoFont);
			mm.XMove=xMove;
			mm.Y=350;

			mm2=env.CenterMessage("[X] or [SHIFT] or [SPACE] - Wv",440,3000,infoFont);
			mm2.XMove=xMove;
			mm2.Y=250;

			mm3=env.CenterMessage("[C] or [Z] or [CTRL] - _bVt@CA[",440,3000,infoFont);
			mm3.XMove=xMove;
			mm3.Y=300;

			mm4=env.CenterMessage("i ĹMj2004 - Kunio Makimoto <kunio@makimo.to> q{ mv",400,3000,smallFont);
			mm4.XMove=xMove;


			logo.SetSize(384,170);
			ptr=(ptr+1) % stage.Length;
		}
		

		public int Action(Graphics g){
		  if(!initFlag)init();
		  innerTimer++;
			env.ScrollLeft+=xMove;
			if(env.ScrollLeft > env.ScrollXmax-512*4){
				env.Mozaic++;
			 if(env.Mozaic>50){
				nextStage();
				env.Mozaic=50;
			 }
			}else{
			 if(env.Mozaic > 0)env.Mozaic--;
			}

			 mm.Visible = (innerTimer%30<15);


			pl.X=env.ScrollLeft + env.VirtualWidth  / 2;
			pl.Y=env.ScrollTop  + env.VirtualHeight / 2;


			env.CallEnemy();
			
			logo.MoveTo(env.ScrollLeft+64,env.ScrollTop+60);
			logo.DrawEntry();
			
			try{
			 env.Enemies.Action();
			 env.Others.Action();
			 env.Effects.Action();
			}catch(Exception e){
			 env.DBG("Exception"+ e);
			}
		
		   if( padCheck() ){
			initFlag=false;
			pl.Visible=true;
			return EnvManager.Gaming;
		   }
		   return EnvManager.Title;
		  }


//-------------------
//-------------------
		private bool padCheck(){
			if( pad.ButtonA !=0 || pad.ButtonB !=0)return true;
			else return false;
		}
/*
		private void drawString(Graphics g,String str,double x,double y){
			g.drawString(str,(float)x,(float)y);
		}
*/
	}


}